// Header definition
const TYPE_TEMP           = 0x01; const LEN_TEMP          = 2;
const TYPE_HUM            = 0x02; const LEN_HUM           = 1;
const TYPE_LIGHT          = 0x04; const LEN_LIGHT         = 2;
const TYPE_SGPS           = 0x05; const LEN_SGPS          = 10; //2, 10
const TYPE_GPS            = 0x06; const LEN_GPS           = 16; //2, 18
const TYPE_VDD            = 0x07; const LEN_VDD           = 2;
const TYPE_ANALOG         = 0x08; const LEN_ANALOG        = 2;
const TYPE_VERSION        = 0x09; const LEN_VERSION       = 3;
const TYPE_COUNT1         = 0x0A; const LEN_COUNT1        = 2;
const TYPE_COUNT2         = 0x0B; const LEN_COUNT2        = 4;
const TYPE_EXT_TEMP       = 0x0C; const LEN_EXT_TEMP      = 2;
const TYPE_INPUT1         = 0x0D; const LEN_INPUT1        = 1;
const TYPE_DISTANCE       = 0x0E; const LEN_DISTANCE      = 2;
const TYPE_MOTION         = 0x0F; const LEN_MOTION        = 1;
const TYPE_IR_TEMP        = 0x10; const LEN_IR_TEMP       = 4;
const TYPE_OCCUPANCY      = 0x11; const LEN_OCCUPANCY     = 1;
const TYPE_WATERLEAK      = 0x12; const LEN_WATERLEAK     = 1;
const TYPE_GRIDEYE        = 0x13; const LEN_GRIDEYE       = 65;
const TYPE_DEVICETYPE     = 0x14; const LEN_DEVICETYPE    = 2;
const TYPE_DATA           = 0x15
const TYPE_IBEACON        = 0x16
const TYPE_LIFT           = 0x17
const TYPE_NOISE          = 0x18; const LEN_NOISE           = 1;
const TYPE_ACC            = 0x19; const LEN_ACC             = 6;
const TYPE_INCLINOMETER   = 0x1a; const LEN_INCLINOMETER    = 4;
const TYPE_SPEED          = 0x1b; const LEN_SPEED           = 2;
const TYPE_SIGNALLEVEL    = 0x1c; const LEN_SIGNALLEVEL     = 2;
const TYPE_WATERLEVEL     = 0x1d; const LEN_WATERLEVEL      = 2;
const TYPE_DIRECTION_A_COUNT  = 0x1e; const LEN_COUNT         = 2;
const TYPE_DIRECTION_B_COUNT  = 0x1f;
const TYPE_ANGULAR_RATE   = 0x20; const LEN_ANGULAR_RATE    = 6;
const TYPE_MAGNETIC_FIELD = 0x21; const LEN_MAGNETIC_FIELD  = 6;
const TYPE_INPUT2         = 0x22; const LEN_INPUT2          = 1;
const TYPE_INPUT3         = 0x23; const LEN_INPUT3          = 1;
const TYPE_TIMESTAMP      = 0x24; const LEN_TIMESTAMP       = 7;
const TYPE_ACC2           = 0x25;
const TYPE_COLOR          = 0x26; const LEN_COLOR           = 8;
const TYPE_WINDSPEED      = 0x27; const LEN_WINDSPEED       = 2;
const TYPE_WINDDIRECTION  = 0x28; const LEN_WINDDIRECTION   = 2;

                                  const LEN_GAS             = 2;
const TYPE_TSP            = 0x30  //總懸浮粒子
const TYPE_PM1_0          = 0x31  //懸浮粒子 PM1.0
const TYPE_PM2_5          = 0x32  //懸浮粒子 PM2.5
const TYPE_PM10           = 0x33  //懸浮粒子 PM10
const TYPE_SO2            = 0x34  //二氧化硫
const TYPE_NO2            = 0x35  //二氧化氮
const TYPE_CO             = 0x36  //一氧化碳
const TYPE_O3             = 0x37  //臭氧
const TYPE_H2S            = 0x38  //硫化氫
const TYPE_CO2            = 0x39  //二氧化碳
const TYPE_TVOC           = 0x3a  //揮發性有機物
const TYPE_HCHO           = 0x3b  //甲醛 Methanal
const TYPE_NH3            = 0x3c  //氨 Ammonia
const TYPE_CH4            = 0x3d  //甲烷 Methane
const TYPE_C3H8           = 0x3e  //丙烷 Propane
const TYPE_C2H5OH         = 0x3f  //乙醇 Ethanol
const TYPE_IBEACON2       = 0x40
const TYPE_VOLTAGE        = 0x41; const LEN_VOLTAGE         = 3;
const TYPE_CURRENT        = 0x42; const LEN_CURRENT         = 3;
const TYPE_POWER          = 0x43; const LEN_POWER           = 3;
const TYPE_ENERGY         = 0x44; const LEN_ENERGY          = 3;

const TYPE_PRESSURE       = 0x45; const LEN_PRESSURE        = 3;
const TYPE_FLOW           = 0x46; const LEN_FLOW            = 2;
const TYPE_CONDUCTIVITY   = 0x47; const LEN_CONDUCTIVITY    = 2;
const TYPE_SENSORBATTERY  = 0x48; const LEN_SENSORBATTERY   = 2;
const TYPE_VELOCITY       = 0x49; const LEN_VELOCITY        = 2;

const TYPE_ANGLE          = 0x4a; const LEN_ANGLE           = 2;
const TYPE_3PVOLTAGE      = 0x4b; const LEN_3PVOLTAGE       = 9;
const TYPE_3PCURRENT      = 0x4c; const LEN_3PCURRENT       = 9;
const TYPE_3PPOWER        = 0x4d; const LEN_3PPOWER         = 9;
const TYPE_3PENERGY       = 0x4e; const LEN_3PENERGY        = 9;
const TYPE_SENSORTYPE     = 0x4f; const LEN_SENSORTYPE      = 2;

                                  const LEN_PARTICLE        = 2;
const TYPE_PARTICLE_0_3   = 0x50;
const TYPE_PARTICLE_0_5   = 0x51;
const TYPE_PARTICLE_1_0   = 0x52;
const TYPE_PARTICLE_2_5   = 0x53;
const TYPE_PARTICLE_5_0   = 0x54;
const TYPE_PARTICLE_10_0  = 0x55;
const TYPE_TVOC_BASE  = 0x56;
const TYPE_ECO2_BASE  = 0x57;


function bin16dec(bin) {
  var num=bin&0xFFFF;
  if (0x8000 & num) {
    num = - (0x010000 - num);
  }
  return num;
}
function bin8dec(bin) {
  var num=bin&0xFF;
  if (0x80 & num) {
    num = - (0x0100 - num);
  }
  return num;
}
function toHex(d) {
    return  ("0"+(Number(d).toString(16))).slice(-2).toUpperCase()
}
function toHex6byte(d) {
    return  ("0"+(Number(d).toString(16))).slice(-6).toUpperCase()
}
function bit_test(num, bit) {
	if ((num & (1 << bit)) != 0) {
		return 1;
	} else {
		return 0;
	}
}

function hex2bin(hex){
    return (parseInt(hex, 16).toString(2)).padStart(8, '0');
}
module.exports = {
  hexToBytes: function(hex) {
    for (var bytes = [], c = 0; c < hex.length; c += 2) {
      bytes.push(parseInt(hex.substr(c, 2), 16));
    }
    return bytes;
  },
  DecodePayload: function(data) {
    var obj = new Object();
    for(i = 0; i < data.length; i++){
      switch(data[i]) {
        case TYPE_DATA:
          var len = data[i+1];
          if (len == 0xff) {
            //ignore the len
            var str = "";
            len = data.length - 2;
            for (var j = 0; j < len; j++) {
              str = str + String.fromCharCode(data[j+i+2]);
            }
            obj.data = str;
            i = data.length;
          } else if (len == 0x00) {
            obj.data = "no data";
            i += 1;
          } else if (len == 0x01) {
            var bitstring;
            bitstring = hex2bin(data[i+2].toString(16));
            var bit;
            var dataarray = [];
            for (j = 0; j < 8 ; j++) {
              bit = parseInt(bitstring.substring(j, j+1));
              dataarray.push(bit);
            }
            obj.data = dataarray;
            i += 2;
          } else if (len == 0x02) {
            var bitstring;
            bitstring = hex2bin(data[i+2].toString(16));
            bitstring = bitstring + hex2bin(data[i+3].toString(16));
            var bit;
            var dataarray = [];
            for (j = 0; j < 16 ; j++) {
              bit = parseInt(bitstring.substring(j, j+1));
              dataarray.push(bit);
            }
            obj.data = dataarray;
            i += 3;
          } else {
            var str = "";
            for (var j = 0; j < len; j++) {
              str = str + String.fromCharCode(data[j+i+2]);
            }
            obj.data = str;
            i += (len+1);
          }
        break;
        case TYPE_TEMP:
          var temp = (data[i+1]<<8)|(data[i+2]);
          temp = (bin16dec(temp))/10;
          obj.temperature = temp;
          i += LEN_TEMP;
        break
        case TYPE_HUM:
          var humidity = (data[i+1]);
          obj.humidity = humidity;
          i += LEN_HUM;
        break
        case TYPE_LIGHT:
          var light = (data[i+1]<<8)|(data[i+2]);
          obj.light = light;
          i += LEN_LIGHT;
        break
        case TYPE_SGPS:
          obj.gps_quality = (data[i+1]);
          obj.gps_satellite = (data[i+2]);
          if (obj.gps_quality == 0) {
            i += 2;
          } else {
            obj.gps_lat = ((data[i+3]<<24)|(data[i+4]<<16)|(data[i+5]<<8)|(data[i+6]))/10000000;
            obj.gps_long = ((data[i+7]<<24)|(data[i+8]<<16)|(data[i+9]<<8)|(data[i+10]))/10000000;
            i += LEN_SGPS;
          }
        break
        case TYPE_GPS:
          obj.gps_quality = (data[i+1]);
          obj.gps_satellite = (data[i+2]);
          if (obj.gps_quality == 0) {
            i += 2;
          } else {
            obj.gps_lat = ((data[i+3]<<24)|(data[i+4]<<16)|(data[i+5]<<8)|(data[i+6]))/10000000;
            obj.gps_long = ((data[i+7]<<24)|(data[i+8]<<16)|(data[i+9]<<8)|(data[i+10]))/10000000;
            obj.gps_altitude = ((data[i+11]<<8)|(data[i+12]))/10;
            obj.gps_speed = ((data[i+13]<<8)|(data[i+14]))/1000;
            obj.gps_course = ((data[i+15]<<8)|(data[i+16]))/100;
            i += LEN_GPS;
          }
        break
        case TYPE_VDD:
          var vdd = (data[i+1]<<8)|(data[i+2]);
          obj.vdd = vdd;
          i += LEN_VDD;
        break
        case TYPE_ANALOG:
          var analog = (data[i+1]<<8)|(data[i+2]);
          obj.analog_mV = analog;
          i += LEN_ANALOG;
        break
        case TYPE_VERSION:
          var major = (data[i+1]);
          var middle = (data[i+2]);
          var minor = (data[i+3]);
          obj.version = major + "." + middle + "." + minor;
          i += LEN_VERSION;
        break
        case TYPE_COUNT1:
          var count = (data[i+1]<<8)|(data[i+2]);
          obj.count = count;
          i += LEN_COUNT1;
        break
        case TYPE_COUNT2:
          var count = (data[i+1]<<24)|(data[i+2]<<16)|(data[i+3]<<8)|(data[i+4]);
          if(count < 0)
            count = count + 4294967296;
          obj.count = count;
          i += LEN_COUNT2;
        break
        case TYPE_EXT_TEMP:
          var temp = (data[i+1]<<8)|(data[i+2]);
          temp = bin16dec(temp)/10;
          obj.external_temperature = temp;
          i += LEN_EXT_TEMP;
        break
        case TYPE_INPUT1:
          var input = (data[i+1]);
          obj.input1 = input;
          obj.digital = input;
          i += LEN_INPUT1;
        break
        case TYPE_DISTANCE:
          var distance = (data[i+1]<<8)|(data[i+2]);
          obj.distance = distance;
          i += LEN_DISTANCE;
        break
        case TYPE_MOTION:
          var motion = (data[i+1]);
          obj.motion = motion;
          i += LEN_MOTION;
        break
        case TYPE_IR_TEMP:
          var iTemp = (data[i+1]<<8)|(data[i+2]);
          iTemp = bin16dec(iTemp);
          var eTemp = (data[i+3]<<8)|(data[i+4]);
          eTemp = bin16dec(eTemp);
          obj.ir_internal_temperature = iTemp;
          obj.ir_external_temperature = eTemp;
          i += LEN_IR_TEMP;
        break
        case TYPE_OCCUPANCY:
          var occupancy = (data[i+1]);
          obj.occupancy = occupancy;
          i += LEN_OCCUPANCY;
        break
        case TYPE_WATERLEAK:
          var waterleak = (data[i+1]);
          obj.waterleak = waterleak;
          i += LEN_WATERLEAK;
        break
        case TYPE_GRIDEYE:
          //TODO
          i+=LEN_GRIDEYE;
        break
        case TYPE_DEVICETYPE:
          var model=(data[i+1]);
          switch((model % 16)) {
            case 1: obj.model = 'Edge Node'; break;
            case 2: obj.model = 'Edge Tag'; break;
            case 3: obj.model = 'Edge Router'; break;
            case 4: obj.model = 'Gateway'; break;
            case 5: obj.model = 'Edge Air'; break;
            case 6: obj.model = 'Edge Lite'; break;
            case 7: obj.model = 'Edge ECO'; break;
            case 8: obj.model = 'Edge ECO2'; break;
          }
          switch (model >> 4) {
            case 0: obj.model = obj.model + ' LoRa'; break;
            case 1: obj.model = obj.model + ' NBIoT'; break;
            case 2: obj.model = obj.model + ' Sigfox'; break;
            case 3: obj.model = obj.model + ' LTE'; break;
          }
          var status = (data[i+2]);
          if (status == 0) {
            obj.status = 'online';
          } else if (status == 1) {
            obj.status = 'active';
          }
          i += LEN_DEVICETYPE;
        break;
        case TYPE_IBEACON2:
        case TYPE_IBEACON:
        var str = "";
        var ibeacon_pair = [];
        var ibeacon_set = [];
        var num = data[i+1];
        var seq = data[i+2];
        if (num == 0) {
          obj.ibeacon_group = 0;
          obj.ibeacon_num = 0;
          obj.ibeacon_set = ibeacon_set;
        } else {
          var j = 0;
          obj.ibeacon_group = parseInt(seq, 16);
          obj.ibeacon_num = parseInt(num, 16)
          for (var k = 0; k < num; k++) {
            str = "";
            for (; j < 6+(k*7); j++) {
              str = str + toHex(data[j+i+3]);
            }
            ibeacon_pair = [str, -data[j+i+3]];
            ibeacon_set.push(ibeacon_pair);
            j++;
          }
          obj.ibeacon_set = ibeacon_set;
          i+= (num*(7)+2);
        }
        break;
        /*
        0x01 for going up
0x02 for stop up
0x03 for going down
0x04 for stop down
0x05 for idle
*/
        case TYPE_LIFT:
          var str = "";
          var num = data[i+1] / 5;
          for (var k = 0; k < num; k++) {
            str = str + "(";
            str = str + data[k*5+i+1+1];
            str = str + ";";
            switch (data[k*5+i+1+2]) {
              case 0x01:
                str = str + 'Going Up';
              break;
              case 0x02:
                str = str + 'Stop Up';
              break;
              case 0x03:
                str = str + 'Going Down';
              break;
              case 0x04:
                str = str + 'Stop Down';
              break;
              case 0x05:
                str = str + 'Idle';
              break;
            }
            str = str + ";";
            str = str + toHex6byte( data[k*5+i+1+3]*256*256 + data[k*5+i+1+4]*256 + data[k*5+i+1+5] ).toString();
            str = str + ")";
          }
          obj.lift = str;
          i += (num*5+1);
        break;
        case TYPE_NOISE: //Noise
          var noise = (data[i+1]);
          obj.noise = noise;
          i += LEN_NOISE;
        break
        case TYPE_ACC:
          var x = (data[i+1]<<8)|(data[i+2]);
          var y = (data[i+3]<<8)|(data[i+4]);
          var z = (data[i+5]<<8)|(data[i+6]);
          x = (bin16dec(x));
          y = (bin16dec(y));
          z = (bin16dec(z));
          obj.acc_delta_x_in_mg = x;
          obj.acc_delta_y_in_mg = y;
          obj.acc_delta_z_in_mg = z;
          i += LEN_ACC;
        break
        case TYPE_ACC2:
          var acc_x=(data[i+1]<<8)|(data[i+2]);
          var acc_y=(data[i+3]<<8)|(data[i+4]);
          var acc_z=(data[i+5]<<8)|(data[i+6]);
          acc_x=(bin16dec(acc_x));
          acc_y=(bin16dec(acc_y));
          acc_z=(bin16dec(acc_z));
          obj.acc_x=acc_x;
          obj.acc_y=acc_y;
          obj.acc_z=acc_z;
          acc_x = acc_x/1000;
          acc_y = acc_y/1000;
          acc_z = acc_z/1000;
          obj.angleX_in_deg = Math.atan(-acc_x/(Math.sqrt(acc_y*acc_y + acc_z*acc_z)))*180/Math.PI;
          obj.angleY_in_deg = -Math.atan(acc_y/(Math.sqrt(acc_x*acc_x + acc_z*acc_z)))*180/Math.PI;
          i+=6;
          break
        case TYPE_INCLINOMETER:
        var ang_x = (data[i+1]<<8)|(data[i+2]);
        var ang_y = (data[i+3]<<8)|(data[i+4]);
        ang_x = (bin16dec(ang_x))/100;
        ang_y = (bin16dec(ang_y))/100;
        obj.angleX_in_deg = ang_x;
        obj.angleY_in_deg = ang_y;
        break;
        case TYPE_SPEED:
          var speed = (data[i+1]<<8)|(data[i+2]);
          obj.speed = speed/100;
          i += LEN_SPEED;
        break;
        case TYPE_SIGNALLEVEL:
          var signallevel=(data[i+1]<<8)|(data[i+2]);
          obj.signal_level=signallevel;
          i += LEN_SIGNALLEVEL;
        break;
        case TYPE_WATERLEVEL:
          var waterlevel = (data[i+1]<<8)|(data[i+2]);
          obj.water_level = waterlevel/100;
          i += LEN_WATERLEVEL;
        break;
        case TYPE_DIRECTION_A_COUNT:
            var acount = (data[i+1]<<8)|(data[i+2]);
            obj.direction_a_count = acount;
            i += LEN_COUNT;
        break
        case TYPE_DIRECTION_B_COUNT:
            var bcount = (data[i+1]<<8)|(data[i+2]);
            obj.direction_b_count = bcount;
            i += LEN_COUNT;
        break
        case TYPE_ANGULAR_RATE:
          var angular_rate_x = (data[i+1]<<8)|(data[i+2]);
          var angular_rate_y = (data[i+3]<<8)|(data[i+4]);
          var angular_rate_z = (data[i+5]<<8)|(data[i+6]);
          angular_rate_x = (bin16dec(angular_rate_x));
          angular_rate_y = (bin16dec(angular_rate_y));
          angular_rate_z = (bin16dec(angular_rate_z));
          obj.angular_rate_delta_x_in_dps = angular_rate_x;
          obj.angular_rate_delta_y_in_dps = angular_rate_y;
          obj.angular_rate_delta_z_in_dps = angular_rate_z;
          i += LEN_ANGULAR_RATE;
        break
        case TYPE_MAGNETIC_FIELD:
          var magnetic_field_x = (data[i+1]<<8)|(data[i+2]);
          var magnetic_field_y = (data[i+3]<<8)|(data[i+4]);
          var magnetic_field_z = (data[i+5]<<8)|(data[i+6]);
          magnetic_field_x = (bin16dec(magnetic_field_x));
          magnetic_field_y = (bin16dec(magnetic_field_y));
          magnetic_field_z = (bin16dec(magnetic_field_z));
          obj.magnetic_delta_x_in_mgauss = magnetic_field_x;
          obj.magnetic_delta_y_in_mgauss = magnetic_field_y;
          obj.magnetic_delta_z_in_mgauss = magnetic_field_z;
          i += LEN_MAGNETIC_FIELD;
        break
        case TYPE_TSP:
          var tsp = (data[i+1]<<8)|(data[i+2]);
          obj.tsp = tsp;
          i += LEN_GAS;
        break;
        case TYPE_PM1_0:
          var pm1 = (data[i+1]<<8)|(data[i+2]);
          obj.pm1 = pm1;
          i += LEN_GAS;
        break;
        case TYPE_PM2_5:
          var pm2 = (data[i+1]<<8)|(data[i+2]);
          obj.pm2 = pm2;
          i += LEN_GAS;
        break;
        case TYPE_PM10:
          var pm10 = (data[i+1]<<8)|(data[i+2]);
          obj.pm10 = pm10;
          i += LEN_GAS;
        break;
        case TYPE_SO2:
          var so2 = (data[i+1]<<8)|(data[i+2]);
          obj.so2 = so2;
          i += LEN_GAS;
        break;
        case TYPE_NO2:
          var no2 = (data[i+1]<<8)|(data[i+2]);
          obj.no2 = no2;
          i += LEN_GAS;
        break;
        case TYPE_CO:
          var co = (data[i+1]<<8)|(data[i+2]);
          obj.co = co;
          i += LEN_GAS;
        break;
        case TYPE_O3:
          var o3 = (data[i+1]<<8)|(data[i+2]);
          obj.o3 = o3;
          i += LEN_GAS;
        break;
        case TYPE_H2S:
          var h2s = (data[i+1]<<8)|(data[i+2]);
          obj.h2s = h2s;
          i += LEN_GAS;
        break;
        case TYPE_CO2:
          var co2 = (data[i+1]<<8)|(data[i+2]);
          obj.co2 = co2;
          i += LEN_GAS;
        break;
        case TYPE_TVOC:
          var tvoc = (data[i+1]<<8)|(data[i+2]);
          obj.tvoc = tvoc;
          i += LEN_GAS;
        break;
        case TYPE_HCHO:
          var hcho = (data[i+1]<<8)|(data[i+2]);
          obj.hcho = hcho;
          i += LEN_GAS;
        break;
        case TYPE_NH3:
          var nh3 = (data[i+1]<<8)|(data[i+2]);
          obj.nh3 = nh3;
          i += LEN_GAS;
        break;
        case TYPE_CH4:
          var ch4 = (data[i+1]<<8)|(data[i+2]);
          obj.ch4 = ch4;
          i += LEN_GAS;
        break;
        case TYPE_C3H8:
          var c3h8 = (data[i+1]<<8)|(data[i+2]);
          obj.c3h8 = c3h8;
          i += LEN_GAS;
        break;
        case TYPE_C2H5OH:
          var c2h5oh = (data[i+1]<<8)|(data[i+2]);
          obj.c2h5oh = c2h5oh;
          i += LEN_GAS;
        break;
        case TYPE_INPUT2:
          var input = (data[i+1]);
          obj.input2 = input;
          i += LEN_INPUT2;
        break
        case TYPE_INPUT3:
          var input = (data[i+1]);
          obj.input3 = input;
          i += LEN_INPUT3;
        break
        case TYPE_TIMESTAMP:
          obj.ts_type = data[i+1];
          obj.ts_year = data[i+2];
          obj.ts_month = data[i+3];
          obj.ts_day = data[i+4];
          obj.ts_hour = data[i+5];
          obj.ts_minute = data[i+6];
          obj.ts_second = data[i+7];
          i += LEN_TIMESTAMP;
        break;
        case TYPE_VOLTAGE:
          var voltage = (data[i+1]<<16)|(data[i+2]<<8)|(data[i+3]);
          obj.voltage_in_mV = voltage;
          i += LEN_VOLTAGE;
        break;
        case TYPE_CURRENT:
          var current = (data[i+1]<<16)|(data[i+2]<<8)|(data[i+3]);
          obj.current_in_mA = current;
          i += LEN_CURRENT;
        break;
        case TYPE_POWER:
          var power = (data[i+1]<<16)|(data[i+2]<<8)|(data[i+3]);
          obj.power_in_mW = power;
          i += LEN_POWER;
        break;
        case TYPE_ENERGY:
          var energy = (data[i+1]<<16)|(data[i+2]<<8)|(data[i+3]);
          obj.energy_in_Wh = energy;
          i += LEN_ENERGY;
        break;
        case TYPE_PRESSURE:
          var pressure = (data[i+1]<<16)|(data[i+2]<<8)|(data[i+3]);
          obj.pressure_in_hPa = pressure/100;
          i += LEN_PRESSURE;
        break;
        case TYPE_COLOR:
          var red = (data[i+1]<<8)|(data[i+2]);
          var green = (data[i+3]<<8)|(data[i+4]);
          var blue = (data[i+5]<<8)|(data[i+6]);
          var white = (data[i+7]<<8)|(data[i+8]);
          obj.red = red;
          obj.blue = blue;
          obj.green = green;
          obj.white = white;
          i += LEN_COLOR;
        break;
        case TYPE_WINDSPEED:
          var windspeed = (data[i+1]<<8)|(data[i+2]);
          obj.windspeed = windspeed/10;
          i += LEN_WINDSPEED;
        break;
        case TYPE_WINDDIRECTION:
          var direction = (data[i+1]<<8)|(data[i+2]);
          obj.winddirection = direction;
          i += LEN_WINDDIRECTION;
        break;
        case TYPE_PARTICLE_0_3:
          var part = (data[i+1]<<8)|(data[i+2]);
          obj.particle_0_3 = part;
          i += LEN_PARTICLE;
        break;
        case TYPE_PARTICLE_0_5:
          var part = (data[i+1]<<8)|(data[i+2]);
          obj.particle_0_5 = part;
          i += LEN_PARTICLE;
        break;
        case TYPE_PARTICLE_1_0:
          var part = (data[i+1]<<8)|(data[i+2]);
          obj.particle_1_0 = part;
          i += LEN_PARTICLE;
        break;
        case TYPE_PARTICLE_2_5:
          var part = (data[i+1]<<8)|(data[i+2]);
          obj.particle_2_5 = part;
          i += LEN_PARTICLE;
        break;
        case TYPE_PARTICLE_5_0:
          var part = (data[i+1]<<8)|(data[i+2]);
          obj.particle_5_0 = part;
          i += LEN_PARTICLE;
        break;
        case TYPE_PARTICLE_10_0:
          var part = (data[i+1]<<8)|(data[i+2]);
          obj.particle_10_0 = part;
          i += LEN_PARTICLE;
        break;
	case TYPE_TVOC_BASE:
          var part = (data[i+1]<<8)|(data[i+2]);
          obj.tvocbase = part;
          i += LEN_PARTICLE;
	break;
       	case TYPE_ECO2_BASE:
          var part = (data[i+1]<<8)|(data[i+2]);
          obj.eco2base = part;
          i += LEN_PARTICLE;
	break;
	 case TYPE_FLOW:
          var flow = (data[i+1]<<8)|(data[i+2]);
          obj.flow_in_m3_per_h = (bin16dec(flow))/1000;
          i += LEN_FLOW;
        break;
        case TYPE_CONDUCTIVITY:
          var conductivity = (data[i+1]<<8)|(data[i+2]);
          obj.conductivity_in_uS_per_cm = (bin16dec(conductivity));
          i += LEN_CONDUCTIVITY;
        break;
        case TYPE_SENSORBATTERY:
          var sensorbattery = (data[i+1]<<8)|(data[i+2]);
          obj.sensorbattery_in_V = (bin16dec(sensorbattery))/1000;
          i += LEN_SENSORBATTERY;
        break;
        case TYPE_VELOCITY:
          var velocity = (data[i+1]<<8)|(data[i+2]);
          obj.velocity_in_m_per_s = (bin16dec(velocity))/1000;
          i += LEN_VELOCITY;
        break;

        case TYPE_ANGLE:
          var angle = (data[i+1]<<8)|(data[i+2]);
          obj.angle_in_deg = (bin16dec(angle));
          i += LEN_ANGLE;
        break;

        case TYPE_3PVOLTAGE:
          var voltage_line1 = (data[i+1]<<16)|(data[i+2]<<8)|(data[i+3]);
          var voltage_line2 = (data[i+4]<<16)|(data[i+5]<<8)|(data[i+6]);
          var voltage_line3 = (data[i+7]<<16)|(data[i+8]<<8)|(data[i+9]);
          obj.voltage_line1_in_mV = voltage_line1;
          obj.voltage_line2_in_mV = voltage_line2;
          obj.voltage_line3_in_mV = voltage_line3;
          i += LEN_3PVOLTAGE;
        break;

        case TYPE_3PCURRENT:
          var current_line1 = (data[i+1]<<16)|(data[i+2]<<8)|(data[i+3]);
          var current_line2 = (data[i+4]<<16)|(data[i+5]<<8)|(data[i+6]);
          var current_line3 = (data[i+7]<<16)|(data[i+8]<<8)|(data[i+9]);
          obj.current_line1_in_mA = current_line1;
          obj.current_line2_in_mA = current_line2;
          obj.current_line3_in_mA = current_line3;
          i += LEN_3PCURRENT;
        break;

        case TYPE_3PPOWER:
          var power_line1 = (data[i+1]<<16)|(data[i+2]<<8)|(data[i+3]);
          var power_line2 = (data[i+4]<<16)|(data[i+5]<<8)|(data[i+6]);
          var power_line3 = (data[i+7]<<16)|(data[i+8]<<8)|(data[i+9]);
          obj.power_line1_in_mW = power_line1;
          obj.power_line2_in_mW = power_line2;
          obj.power_line3_in_mW = power_line3;
          i += LEN_3PPOWER;
        break;

        case TYPE_3PENERGY:
          var energy_line1 = (data[i+1]<<16)|(data[i+2]<<8)|(data[i+3]);
          var energy_line2 = (data[i+4]<<16)|(data[i+5]<<8)|(data[i+6]);
          var energy_line3 = (data[i+7]<<16)|(data[i+8]<<8)|(data[i+9]);
          obj.energy_line1_in_Wh = energy_line1;
          obj.energy_line2_in_Wh = energy_line2;
          obj.energy_line3_in_Wh = energy_line3;
          i += LEN_3PENERGY;
        break;

        case TYPE_SENSORTYPE:
          var sensortype = (data[i+1]<<8)|(data[i+2]);
          obj.sensortype = (bin16dec(sensortype));
          i += LEN_SENSORTYPE;
        break;
        default:
          //somthing is wrong with data
          i=data.length;
        break
      }
    }
    return obj;
  }
};
